<?php
/***************************************\
|			PHP OPTIMISATEUR			|
|			   Version 1.2				|
\***************************************/

set_time_limit(7200);
$TIME_START = microtime(true);

include('files/functions.php');
include('files/header.php');



### DEMARRAGE ###
// Fichier de configuration
if (!file_exists('config.xml')) {
	$Errors['ErrorFile'] = true;
	
} else {
	// Configuration
	extract(load_config());

	// Afficher la configuration
	include('files/display_config.php');

	// Dossiers
	if (!file_exists($DIRsource)) {
		mkdir($DIRsource);
	}
	if (!file_exists($DIRsortie)) {
		mkdir($DIRsortie);
	}
	if (is_dir_empty($DIRsource)) {
		$Errors['ErrorFolderIn'] = true;
	}
	if (!is_dir_empty($DIRsortie) AND $silentORNOT == 'block') {
		$Errors['ErrorFolderOut'] = true;
	}
	if (!file_exists('files\nconvert.exe')) {
		$Errors['ErrorNconvert'] = true;
	}
}



### ERREURS ###
if (isset($Errors)) {
	foreach ($Errors as $key => $null) {
		echo '<div class="error">'.l10n($key).'</div>';
	}
	echo '<div class="link"><a href="index.php">&raquo; '.l10n('Back').'</a> <a href="setup.php">&raquo; '.l10n('Config').'</a></div>';
}



### EXECUTION ###
if (isset($_GET['Process']) AND !isset($Errors)) {
	// Si mode silencieux vidage automatique du dossier de sortie
	if ($silentORNOT == 'erase') {
		rrmdir($DIRsortie);
		mkdir($DIRsortie);
	}

	
	### Supprimer les caractères spéciaux - dossiers & fichiers ###
	// Les caractères '%' et '$' sont systématiquement échappés, ca génère des bugs dans les noms de fichiers
	function recursive_delete_special_car($dir) {
		$dir = rtrim($dir, '/');
		$dh = opendir($dir);
		
		while (($file = readdir($dh)) !== false ) {
			if ($file !== '.' && $file !== '..') {
				$path = $dir.'/'.$file;
				$new_path = $dir.'/'.delete_special_car($file);
				rename($path, $new_path);
				
				if (is_dir($new_path)) {
					recursive_delete_special_car($new_path);
				}
			}
		}
		closedir($dh);
	}

	recursive_delete_special_car($DIRsource);


	### Copyright & Options générales des conversion ###
	$copyright = utf8_decode($copyright);
	$copyCOLOR = hex2RGB(substr($copyCOLOR,1), true, ' ');
	
	if ($copyONhd) {
		$copyHD = '-text_font "'.$copyFONT.'" '.$DIMnormal*$copySIZE.' -text_color '.$copyCOLOR.' -text_flag '.$copyPOS.' -text_pos 0 0 -text "'.$copyright.'"';
	} else {
		$copyHD = null;
	}
	
	if ($copyONnormal) {
		$copyNormal = '-text_font "'.$copyFONT.'" '.$DIMnormal*$copySIZE.' -text_color '.$copyCOLOR.' -text_flag '.$copyPOS.' -text_pos 0 0 -text "'.$copyright.'"';
	} else {
		$copyNormal = null;
	}
	
	$convOptions = '-ratio -rtype lanczos -rflag decr';


	### Plugins avant execution ###
	foreach ($PluginsBefore as $name => $config) {
		if ($config['active']) {
			include('plugins/'.$name.'.php');
		}
	}


	### Processus principal ###
	// Tableau avec les fichiers source
	$FilesSource = array();
	recursive_readdir($DIRsource, 'FilesSource');
	
	// Tableau avec les fichiers de sortie
	$FilesSortie = str_replace($DIRsource, $DIRsortie, $FilesSource);

	// Boucle sur tous les fichiers
	for ($i=0; $i<count($FilesSource); $i++) {
		// Découpe le nom de fichier : dossier/fichier
		preg_match('#(.*)/(.*)$#', $FilesSortie[$i], $matches);
		$FileFolder = $matches[1]; // dossier de sortie
		$FileName = $matches[2]; // nom+ext fichier
			
		// Crée les sous-dossiers de sortie & 'pwg_high' & 'thumbnail'
		if (!file_exists($FileFolder.'/pwg_high') AND $DIRhighORNOT) {
			mkdir($FileFolder.'/pwg_high', 0777, true);
		}
		if (!file_exists($FileFolder.'/thumbnail')) {
			mkdir($FileFolder.'/thumbnail', 0777, true);
		}
		
		// Informations sur le fichier
		exec('files\nconvert.exe -info "'.$FilesSource[$i].'"', $FileInfos);
		for ($m=0; $m<=5; $m++) {
			unset($FileInfos[$m]);
		}
		foreach ($FileInfos as $key) {
			$a = explode(':', $key);
			$FileInfos[trim($a[0])] = trim($a[1]);
		}
			
		// Plugins pendant l'execution
		foreach ($PluginsProcess as $name => $config) {
			if ($config['active']) {
				include('plugins/'.$name.'.php');
			}
		}
		
		// Compresse les fichiers dans le dossier de sortie
		if (!isset($BlockNormal)) { 
			exec('files\nconvert.exe -q '.$Qnormal.' -out jpeg -o "'.$FileFolder.'/'.$FileName.'" -dpi 72 '.$convOptions.' -resize '.$DIMnormal.' '.$DIMnormal.' '.$copyNormal.' "'.$FilesSource[$i].'"');
		}
		if (!isset($BlockThumbnail)) { 
			exec('files\nconvert.exe -q '.$Qthumbnail.' -out jpeg -o "'.$FileFolder.'/thumbnail/'.$prefixe_mini.$FileName.'" -dpi 72 '.$convOptions.' -resize '.$DIMthumbnail.' '.$DIMthumbnail.' -rmeta -rexifthumb "'.$FilesSource[$i].'"');
		}
		if (!isset($BlockHigh) AND $DIRhighORNOT) {
			if ($DIMhdORNOT) {
				exec('files\nconvert.exe -q '.$Qhd.' -out jpeg -o "'.$FileFolder.'/pwg_high/'.$FileName.'" -dpi '.$DPI.' '.$convOptions.' -resize '.$DIMhd.' '.$DIMhd.' '.$copyHD.' "'.$FilesSource[$i].'"');
			} else {
				copy($FilesSource[$i], $FileFolder.'/pwg_high/'.$FileName);
			}
		}
		
		// Réinitialise les bloqueurs
		unset($FileInfos);
		unset($BlockNormal);
		unset($BlockThumbnail);
		unset($BlockHigh);
	}

	
	### Affichage des fichiers traités ###
	echo '<div class="files">
		<h2>'.l10n('Source files').'</h2>
		<ul>';
			foreach ($FilesSource as $value) {
				echo '<li>'.$value.'</li>';
			}
		echo '</ul>
		<i>'.l10n('%d files', count($FilesSource)).'</i>
	</div>';

	unset($FilesSource);
	unset($FilesSortie);


	### Supprime les dossiers vides et copie les fichiers index.php ###
	$DirsSortie = array();
	recursive_readdir($DIRsortie, 'DirsSortie', true);

	foreach($DirsSortie as $dir) {
		if (is_dir_empty($dir)) {
			rmdir($dir);
		} else if ($indexORNOT) {
			copy('files/index.php', $dir.'/index.php');
		}
	}

	unset($DirsSortie);


	### Plugins après execution ###
	foreach ($PluginsAfter as $name => $config) {
		if ($config['active']) {
			include('plugins/'.$name.'.php');
		}
	}


	### Message final ###
	echo '<div class="finish">'.l10n('Finish %d seconds', intval((microtime(true)-$TIME_START))).'</div>
	<div class="link"><a href="index.php">&raquo; '.l10n('Back').'</a> <a href="setup.php">&raquo; '.l10n('Config').'</a></div>';

	
	
### READY ###
} else if (!isset($Errors)) {
	echo '<div class="finish">'.l10n('Ready').' <span id="loader" style="display:none;float:right;margin:-8px 0 -10px 0;"><img src="files/loader.gif" /></span></div>
	<div class="link"><a href="index.php?Process=true" onClick="document.getElementById(\'loader\').style.display=\'block\';">&raquo; '.l10n('Launch').'</a> <a href="setup.php">&raquo; '.l10n('Config').'</a></div>';
}



### FIN ###
echo '<div class="footer">
	2010 - <a href="http://www.strangeplanet.fr">Damien Sorel</a> - <a href="http://fr.piwigo.org/forum/viewtopic.php?id=19117">Forum</a>
</div>

</body>
</html>';
?>